# ============================================================================
# Makefile

#compile : make BIN_TYPE=VOICE

# ============================================================================
CGW_PATH := $(shell pwd)/build/

CHILD_TARGET ?= cabAppA7
PARENT_TARGET ?= cabAppLauncher
REMOTE_DIAG_APP_TARGET ?= remoteDiagApp
LTEAPP_TARGET ?= lteApp
OTA_TEST_TARGET ?= otaTest
OTA_TARGET ?= cgupdate
ACCEL_TARGET ?= accelService
VERBOSE = @

#TOOLCHAIN_PATH = $(CGW_PATH)/../../../../toolchain/ARM_GCC/gcc-arm-none-eabi-5_4-2016q2/bin/
##CC = arm-linux-gnueabihf-gcc-4.8.3
#CC = /home/vivek/Projects/CGW/6ull/fsl-release-bsp/build/tmp/sysroots/x86_64-linux/usr/bin/arm-poky-linux-gnueabi/arm-poky-linux-gnueabi-gcc --sysroot=/home/vivek/Projects/CGW/6ull/fsl-release-bsp/build/tmp/sysroots/adamm-rsm-dev -mfloat-abi=hard
#LD = arm-linux-gnueabihf-ld
#OBJCPY = arm-linux-gnueabihf-objcopy
CC?=gcc
#CC=arm-linux-gnueabihf-gcc

#  Cab GW Application source directories and files
CABAPPA7_SOURCE_DIR = $(CGW_PATH)/../
CABAPPA7_OBJ_DIR = $(CGW_PATH)/cabappa7/
CGW_DIRS += ./rDiag
CGW_DIRS += ./sensors/battery
CGW_DIRS += ./ble/mobile
CGW_DIRS += ./cloud
CGW_DIRS += ./common 
CGW_DIRS += ./dataManagement/configData
CGW_DIRS += ./dataManagement/storage
CGW_DIRS += ./dataManagement/diagnostic 
CGW_DIRS += ./dataManagement/dataControl
CGW_DIRS += ./dataManagement/configuration
CGW_DIRS += ./deviceManager
CGW_DIRS += ./interfaces/uart
CGW_DIRS += ./interfaces/i2c
CGW_DIRS += ./interfaces/eg91ATCmd
CGW_DIRS += ./interfaces/gpio
CGW_DIRS += ./monitoringAndTelemetry
CGW_DIRS += ./ota
CGW_DIRS += ./watchdog
CGW_DIRS += ./sensors/gps
CGW_DIRS += ./sensors/lte
CGW_DIRS += ./sensors/rf
CGW_DIRS += ./sensors/rtc
CGW_DIRS += ./sensors/led
CGW_DIRS += ./sensors/accel
CGW_DIRS += ./utils
CGW_DIRS += ./hwVersion
CHILD_SOURCES += ./main.c

CHILD_SOURCES += $(foreach dir,$(CGW_DIRS), $(wildcard $(dir)/*.c))
CHILD_HEADERS += $(addprefix $(CABAPPA7_SOURCE_DIR)/, $(foreach dir,$(CGW_DIRS), $(wildcard $(dir)/*.h)))
CHILD_FLAGS += $(foreach dir,$(CGW_DIRS), -I$(dir)) 
CHILD_FLAGS += -DCABAPPA7=1

# Remote Diag App source files
REMOTE_DIAG_SOURCE_DIR = $(CGW_PATH)/../
REMOTE_DIAG_OBJ_DIR = $(CGW_PATH)/remotediagapp/
REMOTE_DIAG_APP_SOURCES += ./rDiag/remoteDiagModule.c
REMOTE_DIAG_APP_SOURCES += ./interfaces/gpio/gpio.c
REMOTE_DIAG_APP_SOURCES += ./interfaces/uart/uart.c
REMOTE_DIAG_APP_SOURCES += ./sensors/rf/sub1.c
REMOTE_DIAG_APP_SOURCES += ./sensors/rf/cc1310.c
REMOTE_DIAG_APP_SOURCES += ./sensors/rf/xbr.c
REMOTE_DIAG_APP_SOURCES += ./remoteDiagApp.c
REMOTE_DIAG_APP_SOURCES += ./utils/circularBuffer.c
REMOTE_DIAG_APP_SOURCES += ./utils/memory.c
REMOTE_DIAG_APP_SOURCES += ./sensors/battery/batModule.c
REMOTE_DIAG_APP_SOURCES += ./dataManagement/dataControl/dataControl.c
REMOTE_DIAG_APP_SOURCES += ./dataManagement/storage/dataStorage.c
REMOTE_DIAG_APP_SOURCES += ./dataManagement/diagnostic/diagnostic.c
REMOTE_DIAG_APP_SOURCES += ./dataManagement/configData/configData.c
REMOTE_DIAG_APP_SOURCES += ./dataManagement/storage/sysLogStorage.c
REMOTE_DIAG_APP_SOURCES += ./common/signalRegister.c
REMOTE_DIAG_APP_SOURCES += ./cloud/cloud.c
REMOTE_DIAG_APP_SOURCES += ./cloud/curl.c
REMOTE_DIAG_APP_SOURCES += ./common/error.c
REMOTE_DIAG_APP_SOURCES += ./common/powerControl.c
REMOTE_DIAG_APP_SOURCES += ./utils/sysTimer.c
REMOTE_DIAG_APP_SOURCES += ./utils/cJSON.c
REMOTE_DIAG_APP_SOURCES += ./utils/hashTable.c
REMOTE_DIAG_APP_SOURCES += ./interfaces/eg91ATCmd/eg91ATCmd.c
REMOTE_DIAG_APP_SOURCES += ./watchdog/watchdog.c
REMOTE_DIAG_APP_SOURCES += ./sensors/led/userInterface.c
REMOTE_DIAG_APP_SOURCES += ./sensors/lte/LteModule.c
REMOTE_DIAG_APP_SOURCES += ./sensors/gps/gps.c
REMOTE_DIAG_APP_SOURCES += ./dataManagement/configuration/configuration.c
REMOTE_DIAG_APP_SOURCES += ./ble/mobile/bleUart.c
REMOTE_DIAG_APP_SOURCES += ./ble/mobile/bleUart_command_handlers.c
REMOTE_DIAG_APP_SOURCES += ./temperature_monitor.c
REMOTE_DIAG_APP_SOURCES += ./sensors/accel/accel.c
REMOTE_DIAG_APP_SOURCES += ./otp/otp.c
REMOTE_DIAG_APP_SOURCES += ./hwVersion/hwVersion.c
REMOTE_DIAG_APP_SOURCES += ./snvs_rtc_wakeup.c

REMOTE_DIAG_APP_HEADERS += $(CGW_PATH)/../common/error.h
REMOTE_DIAG_APP_HEADERS += $(CGW_PATH)/../utils/debug.h
REMOTE_DIAG_APP_HEADERS += $(CGW_PATH)/../common/signalRegister.h
REMOTE_DIAG_APP_HEADERS += $(CGW_PATH)/../common/powerControl.h
REMOTE_DIAG_APP_HEADERS += $(CGW_PATH)/../watchdog/watchdog.h
REMOTE_DIAG_APP_HEADERS += $(CGW_PATH)/../dataManagement/storage/dataStorage.h
REMOTE_DIAG_APP_HEADERS += $(CGW_PATH)/../sensors/lte/LteModule.h
REMOTE_DIAG_APP_HEADERS += $(CGW_PATH)/../sensors/gps/gps.h
REMOTE_DIAG_APP_HEADERS += $(CGW_PATH)/../sensors/led/userInterface.h
REMOTE_DIAG_APP_HEADERS += $(CGW_PATH)/../interfaces/eg91ATCmd/eg91ATCmd.h
REMOTE_DIAG_APP_HEADERS += $(CGW_PATH)/../ble/mobile/bleUart.h
REMOTE_DIAG_APP_FLAGS += -I$(CGW_PATH)/../dataManagement/configuration
REMOTE_DIAG_APP_FLAGS += -I$(CGW_PATH)/../dataManagement/storage/
REMOTE_DIAG_APP_FLAGS += -I$(CGW_PATH)/../dataManagement/diagnostic/
REMOTE_DIAG_APP_FLAGS += -I$(CGW_PATH)/../sensors/battery
REMOTE_DIAG_APP_FLAGS += -I$(CGW_PATH)/../common/
REMOTE_DIAG_APP_FLAGS += -I$(CGW_PATH)/../watchdog/
REMOTE_DIAG_APP_FLAGS += -I$(CGW_PATH)/../cloud/
REMOTE_DIAG_APP_FLAGS += -I$(CGW_PATH)/../rDiag/
REMOTE_DIAG_APP_FLAGS += -I$(CGW_PATH)/../utils/
REMOTE_DIAG_APP_FLAGS += -I$(CGW_PATH)/../otp/
REMOTE_DIAG_APP_FLAGS += -I$(CGW_PATH)/../hwVersion/
REMOTE_DIAG_APP_FLAGS += -I$(CGW_PATH)/../cloud
REMOTE_DIAG_APP_FLAGS += -I$(CGW_PATH)/../dataManagement/storage
REMOTE_DIAG_APP_FLAGS += -I$(CGW_PATH)/../dataManagement/dataControl
REMOTE_DIAG_APP_FLAGS += -I$(CGW_PATH)/../interfaces/gpio
REMOTE_DIAG_APP_FLAGS += -I$(CGW_PATH)/../interfaces/uart
REMOTE_DIAG_APP_FLAGS += -I$(CGW_PATH)/../sensors/rf/
REMOTE_DIAG_APP_FLAGS += -I$(CGW_PATH)/../sensors/lte/
REMOTE_DIAG_APP_FLAGS += -I$(CGW_PATH)/../interfaces/eg91ATCmd/
REMOTE_DIAG_APP_FLAGS += -I$(CGW_PATH)/../sensors/led/

REMOTE_DIAG_APP_FLAGS += -I$(CGW_PATH)/../sensors/accel/ 
REMOTE_DIAG_APP_FLAGS += -I$(CGW_PATH)/../dataManagement/configuration/ 
REMOTE_DIAG_APP_FLAGS += -I$(CGW_PATH)/../utils/ 
REMOTE_DIAG_APP_FLAGS += -I$(CGW_PATH)/../rDiag/
REMOTE_DIAG_APP_FLAGS += -I$(CGW_PATH)/../common/
REMOTE_DIAG_APP_FLAGS += -DACCEL_TEMP_APP
REMOTE_DIAG_APP_FLAGS += -DREMOTEDIAGAPP=1


# LTE App application source directories and files
LTEAPP_SOURCE_DIR = $(CGW_PATH)/../
LTEAPP_OBJ_DIR = $(CGW_PATH)/lteApp/
LTEAPP_SOURCES += ./lteApp.c
LTEAPP_SOURCES += ./dataManagement/diagnostic/diagnostic.c
LTEAPP_SOURCES += ./dataManagement/configuration/configuration.c
LTEAPP_SOURCES += ./ble/mobile/bleUart.c
LTEAPP_SOURCES += ./ble/mobile/bleUart_command_handlers.c
LTEAPP_SOURCES += ./watchdog/watchdog.c
LTEAPP_SOURCES += ./common/error.c
LTEAPP_SOURCES += ./interfaces/gpio/gpio.c
LTEAPP_SOURCES += ./sensors/lte/LteModule.c
LTEAPP_SOURCES += ./interfaces/eg91ATCmd/eg91ATCmd.c
LTEAPP_SOURCES += ./rDiag/remoteDiagModule.c
LTEAPP_SOURCES += ./utils/circularBuffer.c
LTEAPP_SOURCES += ./utils/sysTimer.c
LTEAPP_SOURCES += ./sensors/led/userInterface.c
LTEAPP_SOURCES += ./common/signalRegister.c
LTEAPP_SOURCES += ./common/powerControl.c
LTEAPP_SOURCES += ./sensors/battery/batModule.c
LTEAPP_SOURCES += ./sensors/rf/sub1.c
LTEAPP_SOURCES += ./sensors/rf/cc1310.c
LTEAPP_SOURCES += ./sensors/rf/xbr.c
LTEAPP_SOURCES += ./utils/hashTable.c
LTEAPP_SOURCES += ./interfaces/uart/uart.c
LTEAPP_SOURCES += ./utils/cJSON.c
LTEAPP_SOURCES += ./utils/memory.c
LTEAPP_SOURCES += ./dataManagement/storage/sysLogStorage.c
#LTEAPP_SOURCES += $(CGW_PATH)/../monitoringAndTelemetry/monitorAndTelemetry.c
LTEAPP_HEADERS += $(CGW_PATH)/../watchdog/watchdog.h
LTEAPP_HEADERS += $(CGW_PATH)/../common/error.h
LTEAPP_HEADERS += $(CGW_PATH)/../utils/debug.h
LTEAPP_HEADERS += $(CGW_PATH)/../sensors/lte/LteModule.h
LTEAPP_HEADERS += $(CGW_PATH)/../interfaces/eg91ATCmd/eg91ATCmd.h
LTEAPP_HEADERS += $(CGW_PATH)/../interfaces/gpio/gpio.h
LTEAPP_HEADERS += $(CGW_PATH)/../monitoringAndTelemetry/monitorAndTelemetry.h
LTEAPP_HEADERS += $(CGW_PATH)/../utils/sysTimer.h
LTEAPP_HEADERS += $(CGW_PATH)/../sensors/led/userInterface.h
LTEAPP_HEADERS += $(CGW_PATH)/../common/signalRegister.h
LTEAPP_HEADERS += $(CGW_PATH)/../common/powerControl.h
LTEAPP_HEADERS += $(CGW_PATH)/../sensors/rf/xbr.h
LTEAPP_HEADERS += $(CGW_PATH)/../utils/hashTable.h
LTEAPP_HEADERS += $(CGW_PATH)/../ble/mobile/bleUart.h
LTEAPP_FLAGS += -I$(CGW_PATH)/../watchdog/
LTEAPP_FLAGS += -I$(CGW_PATH)/../sensors/battery
LTEAPP_FLAGS += -I$(CGW_PATH)/../sensors/rf/
LTEAPP_FLAGS += -I$(CGW_PATH)/../rDiag/
LTEAPP_FLAGS += -I$(CGW_PATH)/../utils/
LTEAPP_FLAGS += -I$(CGW_PATH)/../common/
LTEAPP_FLAGS += -I$(CGW_PATH)/../interfaces/gpio/
LTEAPP_FLAGS += -I$(CGW_PATH)/../dataManagement/configuration/
LTEAPP_FLAGS += -I$(CGW_PATH)/../interfaces/eg91ATCmd/
LTEAPP_FLAGS += -I$(CGW_PATH)/../sensors/lte/
LTEAPP_FLAGS += -I$(CGW_PATH)/../dataManagement/diagnostic/
LTEAPP_FLAGS += -I$(CGW_PATH)/../monitoringAndTelemetry/
LTEAPP_FLAGS += -I$(CGW_PATH)/../sensors/led/
LTEAPP_FLAGS += -I$(CGW_PATH)/../interfaces/uart
LTEAPP_FLAGS += -I$(CGW_PATH)/../dataManagement/storage
LTEAPP_FLAGS += -I$(CGW_PATH)/../cloud
LTEAPP_FLAGS += -DLTEAPP=1


#  Cab GW parent application source directories and files
PARENT_SOURCE_DIR = $(CGW_PATH)/../
PARENT_OBJ_DIR = $(CGW_PATH)/parent
CGW_PARENT_DIRS += ./sensors/battery
CGW_PARENT_DIRS += ./rDiag
CGW_PARENT_DIRS += ./interfaces/gpio
CGW_PARENT_DIRS += ./sensors/led
CGW_PARENT_DIRS += ./dataManagement/configuration
CGW_PARENT_DIRS += ./utils
#PARENT_SOURCES += ./rDiag/remoteDiagModule.c
#PARENT_SOURCES += ./utils/circularBuffer.c
PARENT_SOURCES += ./common/error.c
PARENT_SOURCES += ./common/powerControl.c
PARENT_SOURCES += ./ble/mobile/bleUart.c
PARENT_SOURCES += ./ble/mobile/bleUart_command_handlers.c
PARENT_SOURCES += ./dataManagement/diagnostic/diagnostic.c
PARENT_SOURCES += ./watchdog/watchdog.c
PARENT_SOURCES += ./ota/otaEnv.c
PARENT_SOURCES += ./parentApp.c
PARENT_SOURCES += ./dataManagement/storage/sysLogStorage.c
PARENT_SOURCES += ./interfaces/eg91ATCmd/eg91ATCmd.c
PARENT_HEADERS += $(CGW_PATH)/../common/error.h
PARENT_HEADERS += $(CGW_PATH)/../common/powerControl.h
PARENT_HEADERS += $(CGW_PATH)/../ble/mobile/bleUart.h
PARENT_HEADERS += $(CGW_PATH)/../interfaces/eg91ATCmd/eg91ATCmd.h
PARENT_FLAGS += -I$(CGW_PATH)/../common/
PARENT_FLAGS += -I$(CGW_PATH)/../sensors/battery
PARENT_FLAGS += -I$(CGW_PATH)/../ota/
PARENT_FLAGS += -I$(CGW_PATH)/../watchdog
PARENT_FLAGS += -I$(CGW_PATH)/../dataManagement/diagnostic/
PARENT_FLAGS += -I$(CGW_PATH)/../dataManagement/storage
PARENT_FLAGS += -I$(CGW_PATH)/../cloud
PARENT_FLAGS += -I$(CGW_PATH)/../interfaces/eg91ATCmd
PARENT_FLAGS += -DCABAPPLAUNCHER=1

PARENT_SOURCES += $(foreach dir,$(CGW_PARENT_DIRS), $(wildcard $(dir)/*.c)) 
PARENT_HEADERS += $(addprefix $(PARENT_SOURCES)/, $(foreach dir,$(CGW_PARENT_DIRS), $(wildcard $(dir)/*.h)))
PARENT_FLAGS += $(foreach dir,$(CGW_PARENT_DIRS), -I$(dir))

#cab GW OTA Test utils source files and directories
OTA_TEST_SOURCE_DIR ?= $(CGW_PATH)/../
OTA_TEST_OBJ_DIR ?= $(CGW_PATH)/ota_test
OTA_TEST_SOURCES += ./common/error.c
OTA_TEST_SOURCES += ./rDiag/remoteDiagModule.c
OTA_TEST_SOURCES += ./utils/circularBuffer.c
OTA_TEST_SOURCES += ./dataManagement/diagnostic/diagnostic.c
OTA_TEST_SOURCES += ./dataManagement/configuration/configuration.c
OTA_TEST_SOURCES += ./watchdog/watchdog.c
OTA_TEST_SOURCES += ./ble/mobile/bleUart.c
OTA_TEST_SOURCES += ./ble/mobile/bleUart_command_handlers.c
OTA_TEST_SOURCES += ./utils/cJSON.c
OTA_TEST_SOURCES += ./otaTest.c
OTA_TEST_SOURCES += ./dataManagement/storage/sysLogStorage.c
OTA_TEST_HEADERS += $(CGW_PATH)/../common/error.h
OTA_TEST_HEADERS += $(CGW_PATH)/../utils/debug.h
OTA_TEST_HEADERS += $(CGW_PATH)/../rDiag/remoteDiagModule.h
OTA_TEST_FLAGS += -I$(CGW_PATH)/../sensors/battery
OTA_TEST_FLAGS += -I$(CGW_PATH)/../common
OTA_TEST_FLAGS += -I$(CGW_PATH)/../rDiag
OTA_TEST_FLAGS += -I$(CGW_PATH)/../utils
OTA_TEST_FLAGS += -I$(CGW_PATH)/../ota
OTA_TEST_FLAGS += -I$(CGW_PATH)/../cloud
OTA_TEST_FLAGS += -I$(CGW_PATH)/../dataManagement/configuration
OTA_TEST_FLAGS += -I$(CGW_PATH)/../watchdog
OTA_TEST_FLAGS += -I$(CGW_PATH)/../dataManagement/diagnostic/
OTA_TEST_FLAGS += -I$(CGW_PATH)/../ble/mobile/
OTA_TEST_FLAGS += -DOTATESTFLAG=1

OTA_SOURCE_DIR = $(CGW_PATH)/../
OTA_OBJ_DIR = $(CGW_PATH)/ota
OTA_SOURCES = $(foreach dir,$(CGW_DIRS), $(wildcard $(dir)/*.c)) ./zipUpdate.c

#Accelerometer service source files and dirs
ACCEL_SOURCE_DIR = $(CGW_PATH)/../
ACCEL_OBJ_DIR = $(CGW_PATH)/accel/
ACCEL_DIRS += ./interfaces/gpio
ACCEL_DIRS += ./interfaces/uart
ACCEL_DIRS += ./sensors/led
ACCEL_DIRS += ./sensors/rf
ACCEL_DIRS += ./sensors/accel
ACCEL_DIRS += ./sensors/battery
ACCEL_DIRS += ./utils/
ACCEL_DIRS += ./rDiag/
ACCEL_SOURCES += ./common/error.c
ACCEL_SOURCES += ./common/signalRegister.c
ACCEL_SOURCES += ./watchdog/watchdog.c
ACCEL_SOURCES += ./dummy-iiostream.c
ACCEL_HEADERS += $(CGW_PATH)/../common/error.h
ACCEL_FLAGS += -I$(CGW_PATH)/../sensors/battery
ACCEL_FLAGS += -I$(CGW_PATH)/../watchdog
ACCEL_FLAGS += -I$(CGW_PATH)/../common
ACCEL_FLAGS += -I$(CGW_PATH)/../rDiag
ACCEL_FLAGS += -I$(CGW_PATH)/../sensors/rf
ACCEL_FLAGS += -I$(CGW_PATH)/../dataManagement/configuration

ACCEL_SOURCES += $(foreach dir,$(ACCEL_DIRS), $(wildcard $(dir)/*.c)) 
ACCEL_HEADERS += $(addprefix $(ACCEL_SOURCE_DIR)/, $(foreach dir,$(ACCEL_DIRS), $(wildcard $(dir)/*.h)))
ACCEL_FLAGS += $(foreach dir,$(ACCEL_DIRS), -I$(dir))
ACCEL_FLAGS += -DACCEL_SUPPORT


# Extra files to be removed
SWAPFILES = $(foreach dir,$(CGW_DIRS), $(wildcard $(dir)/*.swp))
SWAPFILES += $(foreach dir,$(CGW_PARENT_DIRS), $(wildcard $(dir)/*.swp))
SWAPFILES += $(foreach dir,$(ACCEL_DIRS), $(wildcard $(dir)/*.swp))

OPENFILES = $(foreach dir,$(CGW_DIRS), $(wildcard $(dir)/*~))
OPENFILES += $(foreach dir,$(CGW_PARENT_DIRS), $(wildcard $(dir)/*~))
OPENFILES += $(foreach dir,$(ACCEL_DIRS), $(wildcard $(dir)/*~))

BACKUPFILES = $(foreach dir,$(CGW_DIRS), $(wildcard $(dir)/*.bak))
BACKUPFILES += $(foreach dir,$(CGW_PARENT_DIRS), $(wildcard $(dir)/*.bak))
BACKUPFILES += $(foreach dir,$(ACCEL_DIRS), $(wildcard $(dir)/*.bak))

CHILD_OBJFILES = $(addprefix $(CABAPPA7_OBJ_DIR)/, $(CHILD_SOURCES:%.c=%.o))
CHILD_SOURCES_FULL_PATH = $(addprefix $(CABAPPA7_SOURCE_DIR)/, $(CHILD_SOURCES))
OTA_OBJFILES = $(addprefix $(OTA_OBJ_DIR)/, $(OTA_SOURCES:%.c=%.o))
OTA_SOURCES_FULL_PATH = $(addprefix $(OTA_SOURCE_DIR)/, $(OTA_SOURCES))
PARENT_OBJFILES = $(addprefix $(PARENT_OBJ_DIR)/, $(PARENT_SOURCES:%.c=%.o))
PARENT_SOURCES_FULL_PATH = $(addprefix $(PARENT_SOURCE_DIR)/, $(PARENT_SOURCES))
REMOTE_DIAG_APP_OBJFILES = $(addprefix $(REMOTE_DIAG_OBJ_DIR)/, $(REMOTE_DIAG_APP_SOURCES:%.c=%.o))
REMOTE_DIAG_APP_SOURCES_FULL_PATH = $(addprefix $(REMOTE_DIAG_SOURCE_DIR)/, $(REMOTE_DIAG_APP_SOURCES))
LTEAPP_OBJFILES = $(addprefix $(LTEAPP_OBJ_DIR)/, $(LTEAPP_SOURCES:%.c=%.o))
LTEAPP_SOURCES_FULL_PATH = $(addprefix $(LTEAPP_SOURCE_DIR)/, $(LTEAPP_SOURCES))
OTA_TEST_OBJFILES = $(addprefix $(OTA_TEST_OBJ_DIR)/, $(OTA_TEST_SOURCES:%.c=%.o))
OTA_TEST_SOURCES_FULL_PATH = $(addprefix $(OTA_TEST_SOURCE_DIR)/, $(OTA_TEST_SOURCES))
ACCEL_OBJFILES = $(addprefix $(ACCEL_OBJ_DIR)/, $(ACCEL_SOURCES:%.c=%.o))
ACCEL_SOURCES_FULL_PATH = $(addprefix $(ACCEL_SOURCE_DIR)/, $(ACCEL_SOURCES))
#LIBS =   $(CGW_PATH)/../lib/libcrypto.a $(NMSDIR)/../lib/libssl.a -lpthread

C_FLAGS += -Wall --std=c99 -D_POSIX_C_SOURCE=199309L -g -DBUILD=RELEASE -D _GNU_SOURCE -DLINUX -DGET_CPU_LOAD -Wno-implicit -fno-builtin $(PLATFORM_CPPFLAGS)
LIB_FLAGS= -lgcc -lpthread -lm -lrt -lssl -lcrypto -lcurl -liio
#C_FLAGS += -Wall --std=c99 -D_POSIX_C_SOURCE=199309L -g -DBUILD=DEBUG -DENABLE_DBG_LEVEL=3 -D _GNU_SOURCE -DLINUX -DGET_CPU_LOAD -Wno-implicit -fno-builtin $(PLATFORM_CPPFLAGS) $(INCLUDE_DIRS)
#LIB_FLAGS= -lgcc -lpthread -lm -lrt -lssl -lcrypto 
#LIB_FLAGS= -L $(CGW_PATH)/../libs/ -lgcc -lasound -lpthread -lm -lcurl -lcrypto -lssl
#LIB_FLAGS= -L /home/vivek/Projects/CGW/6ull/fsl-release-bsp/build/tmp/sysroots/adamm-rsm-dev/usr/lib -lgcc -lasound -lpthread -lm -lcurl -lcrypto -lssl

.PHONY: clean

all: setup $(CHILD_TARGET) $(PARENT_TARGET) $(OTA_TARGET) $(OTA_TEST_TARGET) $(REMOTE_DIAG_APP_TARGET) $(LTEAPP_TARGET) 
$(CHILD_TARGET): $(CHILD_OBJFILES)
	@echo
	@echo Linking $@ from $^..
	$(CC) -o ./out/$@ $^ $(LIBS) $(LIB_FLAGS)

$(PARENT_TARGET): $(PARENT_OBJFILES)
	@echo
	@echo Linking $@ from $^..
	$(CC) -o ./out/$@ $^ $(LIBS) $(LIB_FLAGS)

$(OTA_TARGET): $(OTA_OBJFILES)
	@echo
	@echo Linking $@ from $^..
	$(CC) -o ./out/$@ $^ $(LIBS) $(LIB_FLAGS)

$(OTA_TEST_TARGET): $(OTA_TEST_OBJFILES)
	@echo
	@echo Linking $@ from $^..
	$(CC) -o ./out/$@ $^ $(LIBS) $(LIB_FLAGS)

$(REMOTE_DIAG_APP_TARGET): $(REMOTE_DIAG_APP_OBJFILES)
	@echo
	@echo Linking $@ from $^..
	$(CC) -o ./out/$@ $^ $(LIBS) $(LIB_FLAGS)

$(LTEAPP_TARGET): $(LTEAPP_OBJFILES)
	@echo
	@echo Linking $@ from $^..
	$(CC) -o ./out/$@ $^ $(LIBS) $(LIB_FLAGS)

$(SNVS_RTC_WAKEUP_TARGET): $(SNVS_RTC_WAKEUP_OBJFILES)
	@echo
	@echo Linking $@ from $^..
	$(CC) -o ./out/$@ $^ $(LIBS) $(LIB_FLAGS)

$(ACCEL_TARGET): $(ACCEL_OBJFILES)
	@echo
	@echo Linking $@ from $^..
	$(CC) -o ./out/$@ $^ $(LIBS) $(LIB_FLAGS)

setup:
	@mkdir -p $(CGW_PATH)
	@mkdir -p $(CGW_PATH)/../out/
	@echo $(CHILD_SOURCES)
	

$(PARENT_OBJFILES): $(PARENT_OBJ_DIR)/%.o : $(PARENT_SOURCE_DIR)/%.c
	@echo parent Compiling $@ from $<..
	@mkdir -p $(@D)
	$(VERBOSE) $(CC) $(C_FLAGS) $(PARENT_FLAGS) -c -o $@ $<

$(CHILD_OBJFILES): $(CABAPPA7_OBJ_DIR)/%.o : $(CABAPPA7_SOURCE_DIR)/%.c  
	@echo child Compiling $@ from $<..
	@mkdir -p $(@D)
	$(VERBOSE) $(CC) $(CHILD_FLAGS) $(C_FLAGS) -c -o $@ $<

$(OTA_OBJFILES): $(OTA_OBJ_DIR)/%.o : $(OTA_SOURCE_DIR)/%.c 
	@echo ota mainCompiling $@ from $<..
	@mkdir -p $(@D)
	$(VERBOSE) $(CC) $(CHILD_FLAGS) $(C_FLAGS) -c -o $@ $<

$(OTA_TEST_OBJFILES): $(OTA_TEST_OBJ_DIR)/%.o : $(OTA_TEST_SOURCE_DIR)/%.c 
	@echo ota test Compiling $@ from $<..
	@mkdir -p $(@D)
	$(VERBOSE) $(CC) $(OTA_TEST_FLAGS) $(C_FLAGS) -c -o $@ $<

$(REMOTE_DIAG_APP_OBJFILES): $(REMOTE_DIAG_OBJ_DIR)/%.o : $(REMOTE_DIAG_SOURCE_DIR)/%.c 
	@echo remote Compiling $@ from $<..
	@mkdir -p $(@D)
	$(VERBOSE) $(CC) $(REMOTE_DIAG_APP_FLAGS) $(C_FLAGS) -c -o $@ $<

$(LTEAPP_OBJFILES): $(LTEAPP_OBJ_DIR)/%.o : $(LTEAPP_SOURCE_DIR)/%.c 
	@echo LteApp Compiling $@ from $<..
	@mkdir -p $(@D)
	$(VERBOSE) $(CC) $(LTEAPP_FLAGS) $(C_FLAGS) -c -o $@ $<


$(ACCEL_OBJFILES): $(ACCEL_OBJ_DIR)/%.o : $(ACCEL_SOURCE_DIR)/%.c 
	@echo Compiling $@ from $<..
	@mkdir -p $(@D)
	$(VERBOSE) $(CC) $(ACCEL_FLAGS) $(C_FLAGS) -c -o $@ $<

#indent:
#	@indent -br ../include/*.h ../src/*.c
#	@rm -rf ../include/*~ ../src/*~

distclean: clean

clean:
	@echo Removing generated files..
	$(VERBOSE) -$(RM) -rf $(PARENT_OBJFILES) $(CHILD_OBJFILES) $(OTA_OBJFILES) $(OTA_TEST_OBJFILES) $(ACCEL_OBJFILES) $(LTEAPP_OBJFILES) $(REMOTE_DIAG_APP_OBJFILES) ./out/$(OTA_TEST_TARGET) ./out/$(CHILD_TARGET) ./out/$(PARENT_TARGET) ./out/$(OTA_TARGET) ./out/$(ACCEL_TARGET) ./out/$(LTEAPP_TARGET) ./out/$(REMOTE_DIAG_APP_TARGET) *~ *.o *.bak $(SWAPFILES) $(OPENFILES) $(BACKUPFILES)


